import os
import sys
import networkx as nx
from multiprocessing import Pool
import pickle as pk
indir=sys.argv[1]
n=int(sys.argv[2])
queries=[]
from scipy.linalg import eigvalsh
from scipy.sparse.linalg import eigsh
def spLP(G):
    return eigsh(nx.normalized_laplacian_matrix(G,weight=None), k=G.number_of_nodes()-1, tol=0.001, return_eigenvectors=False)
def normspec(G):
    return eigsh(nx.normalized_laplacian_matrix(G,weight=None), k=G.number_of_nodes()-1, tol=0.001, return_eigenvectors=False)
    #return eigvalsh(nx.normalized_laplacian_matrix(G,weight=None))
for root, dirs, filenames in os.walk(indir):
	for f in filenames:
		if not ".count" in f and 'ChungLu' not in f: 
			queries.append(os.path.join(root, f))

def convertv(fn):
    f=open(fn,'r')
    fout=open(fn+'O1','w')
    for line in f.readlines():
        line=line.split(' ')
        fout.write(str(int(line[0])+1)+'\t'+str(int(line[1])+1)+'\n')
    f.close()
    fout.close()
    return 1    
def convert(fn):
    G=nx.read_edgelist(fn,data=False)
    G.remove_edges_from(G.selfloop_edges())
    G.remove_nodes_from(nx.isolates(G))
    G=nx.relabel_nodes(G,{G.nodes()[i]:i+1 for i in range(nx.number_of_nodes(G))})
    nx.write_edgelist(G,fn+'mod',delimiter='\t',data=False)
    return 1     

sdir=os.getcwd()+'/'

def count(name):
    G=nx.read_edgelist(name,data=False)
    G.remove_edges_from(G.selfloop_edges())
    G.remove_nodes_from(nx.isolates(G))
    t=nx.laplacian_spectrum(G)
    f=open(name+'.countLP','wb')
    pk.dump(t.real,f)
    f.close()
    return 1
def countA(name):
    G=nx.read_edgelist(name,data=False)
    G.remove_edges_from(G.selfloop_edges())
    G.remove_nodes_from(nx.isolates(G))
    t=nx.adjacency_spectrum(G)
    f=open(name+'.countAD','wb')
    pk.dump(t.real,f)
    f.close()
    return 1
def countN(name):
    G=nx.read_edgelist(name,data=False)
    G.remove_edges_from(G.selfloop_edges())
    G.remove_nodes_from(nx.isolates(G))
    t=normspec(G)
    f=open(name+'.countNLP','wb')
    pk.dump(t.real,f)
    f.close()
    return 1   
    

if __name__ == '__main__':
        p = Pool(n)
        c=p.map(count, queries)
	#c=p.map(countA, queries)
	c=p.map(countN, queries)
